#!/usr/bin/python3
# -*- coding: utf-8 -*-
""" Demonstration d'un interblocage a l'occasion de l'ecriture dans un
fichier """

from random import choice
from time import sleep
from filelock import (
    FileLock,
)  # apt-get install python3-filelock  ou pip/pip3 install filelock


def main(caracteres):
    """
    Boucle sans fin choisissant un caractere au hasard et l'écrivant dans le fichier
    apres verrouillage puis liberation de l'ancien verrou
    """
    compteur = 0
    caractere = ""
    verrou = None
    while True:
        precedent = caractere
        caractere = choice(caracteres)
        compteur = compteur + 1
        print(
            "\r",
            compteur,
            "  verrouiller:",
            caractere,
            "  libérer:",
            precedent,
            end="",
            flush=True,
        )
        if caractere != precedent:
            ancien_verrou = verrou
            verrou = FileLock(caractere + ".lock")
            verrou.acquire()
            if ancien_verrou is not None:
                ancien_verrou.release()
        fichier = open(caractere, "w")
        fichier.write(caractere)
        fichier.close()
        sleep(0.1)


main("ABCDEFGHIJ")
